#include <stdio.h>
#include <stdlib.h>

typedef struct listNode {
	char data;
	struct listNode *next;
}LISTNODE;

typedef LISTNODE *LPT;

int insert(LPT *, char);
char delete(LPT *, char);
int printList(LPT);

int main(void)
{
	LPT startPtr = NULL;
	int input;
	char node;
	do
	{
		printf("1 :  (ĺ )\n2 :  \n3 : \n");
		printf("===================================\n");
		printf("Ʈ  ۾ ϼ : ");
		scanf("%d", &input);
		switch (input)
		{
		case 1:printf("Ʈ   Է : ");
			scanf("%s", &node);
			insert(&startPtr, node);
			printList(startPtr);
			break;
		case 2:
			if (!(startPtr == NULL))
			{
				printf("Ʈ   Է : ");
				scanf("\n%c", &node);
				if (delete(&startPtr, node))
				{
					printf(" %c Ǿϴ\n", node);
					printList(startPtr);
				}
				else
					printf(" %c  ʽϴ\n", node);
			}
			else
				printf("Ʈ ϴ\n");
			break;
		case 3:
			printf(" Ǿϴ\n");
			exit(0);
		default:
			printf("߸ ߽ϴ\n\n");
			break;
		}
	} while (input != 3);
	return 0;
}

int insert(LPT *sPtr, char value)
{
	LPT newPtr, previousPtr, currentPtr;
	newPtr = malloc(sizeof(LISTNODE));
	if (newPtr != NULL)
	{
		newPtr->data = value;
		newPtr->next = NULL;
		previousPtr = NULL;
		currentPtr = *sPtr;
		while (currentPtr != NULL && value > currentPtr->data)
		{
			previousPtr = currentPtr;
			currentPtr = currentPtr->next;
		}
		if (previousPtr == NULL)
		{
			newPtr->next = *sPtr;
			*sPtr = newPtr;
		}
		else
		{
			previousPtr->next = newPtr;
			newPtr->next = currentPtr;
		}
	}
	else
		printf(" %c  Ͽϴ\n", value);
	return 0;
}

char delete(LPT *sPtr, char value)
{
	LPT previousPtr, currentPtr, tempPtr;

	if (value == (*sPtr)->data)
	{
		tempPtr = *sPtr;
		*sPtr = (*sPtr)->next;
		free(tempPtr);
		return value;
	}
	else
	{
		previousPtr = *sPtr;
		currentPtr = (*sPtr)->next;
		while (currentPtr != NULL && currentPtr->data != value)
		{
			previousPtr = currentPtr;
			currentPtr = currentPtr->next;
		}
		if (currentPtr != NULL)
		{
			tempPtr = currentPtr;
			previousPtr->next = currentPtr->next;
			free(tempPtr);
			return value;
		}
	}
	return 0;
}

int printList(LPT currentPtr)
{
	if (currentPtr == NULL)
		printf("Ʈ ϴ\n");
	else
	{
		printf(" Ʈ : \n\n");
		while (currentPtr != NULL)
		{
			printf("%c --> ", currentPtr->data);
			currentPtr = currentPtr->next;
		}
		printf("NULL\n\n");
	}
	return 0;
}