#include <stdio.h>
#include <stdlib.h>

typedef struct stackNode {
	int data;
	struct stackNode *next;
}STACKNODE;

typedef STACKNODE *SPT;

void push(SPT *, int);
int pop(SPT *);
void printStack(SPT);

int main(void)
{
	SPT stackPtr = NULL;
	int input, data;
	do
	{
		printf("1 : ÿ push\n2 : κ pop\n3 : \n");
		printf("===================================\n");
		printf("ÿ  ۾ ϼ : ");
		scanf("%d", &input);
		switch (input)
		{
		case 1:printf("   Է : ");
			scanf("%d", &data);
			push(&stackPtr, data);
			printStack(stackPtr);
			break;
		case 2:
			if (!(stackPtr == NULL))
			{
				pop(&stackPtr);
				printStack(stackPtr);
			}
			else
				printf("STACK EMPTY\n");
			break;
		case 3:
			printf(" Ǿϴ\n");
			exit(0);
		default:
			printf("߸ ߽ϴ\n\n");
			break;
		}
	} while (input != 3);
	return 0;
}

void push(SPT *topPtr, int data)
{
	SPT newPtr;

	newPtr = malloc(sizeof(STACKNODE));
	if (newPtr != NULL)
	{
		newPtr->data = data;
		newPtr->next = *topPtr;
		*topPtr = newPtr;
		printf("Ե ʹ %d\n", data);
	}
	else
		printf(" Ҵ \n");
}

int pop(SPT *topPtr)
{
	SPT tempPtr;

	int popdata;

	tempPtr = *topPtr;
	popdata = (*topPtr)->data;
	*topPtr = (*topPtr)->next;
	free(tempPtr);
	printf("pop ڴ %d\n", popdata);
	return popdata;
}


void printStack(SPT currentPtr)
{
	if (currentPtr == NULL)
		printf("STACK EMPTY\n");
	else
	{
		printf("STACK IS : \n");
		while (currentPtr != NULL)
		{
			printf("%d ==>", currentPtr->data);
			currentPtr = currentPtr->next;
		}
		printf("NULL\n\n");
	}
}

